<!DOCTYPE html>
<html lang="en"
      xmlns:th="http://www.thymeleaf.org"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layout}">
<head>
  <meta charset="UTF-8">
  <title>SI-BKD Ploting Asesor</title>
</head>
<body>

<div layout:fragment="main" class="container">
  <div class="row justify-content-center">
    <!--    <div class="row justify-content-center mb-3">-->
    <div class="col-md-12 mb-3">
      <H3 class="text-black">Ploting Asesor</H3>
    </div>
    <!--    </div>-->
    <form method="get">
      <div class="row justify-content-center mb-3">

        <div class="col-md-4">
          <select class="form-select select2" name="perguruanTinggi" aria-label="Default select example">
            <option value="-" selected>Semua</option>
            <option th:each="data : ${listPerguruanTinggi}"
                    th:selected="(${data} == *{perguruanTinggiSelected})"
                    th:text="${data.namaPerguruanTinggi}"
                    th:value="${data.id}">Dosen Biasa</option>
          </select>
        </div>
        <div class="col-md-7">
          <input type="text" class="form-control" name="cari" th:value="${ada}" placeholder="Cari pengguna berdasarkan nama" aria-label="First name">
        </div>
        <div class="col-md-1 d-grid gap-2">
          <button type="submit" class="btn btn-success">Cari</button>
        </div>

      </div>
    </form>
    <!--    <div class="row justify-content-center">-->
    <div class="col-md-12">
      <table class="table table-striped table-hover mb-3">
        <thead class="table-dark bg-success" style="--bs-table-bg:bg-success;">
        <tr>
          <th class="p-3" style="width: 10px">No</th>
          <th class="p-3" style="width: 25%">Nama Dosen</th>
          <th class="p-3" style="width: 25%">Perguruan Tinggi</th>
          <th class="p-3" style="width: 25%">Asesor 1</th>
          <th class="p-3" style="width: 25%">Asesor 2</th>
          <th class="p-3" style="width: 10px"></th>
        </tr>
        </thead>
        <tbody>
        <tr th:each="dataDosen,row : ${listDosen}">
          <td class="p-3" th:text="${(row.index + 1) + (listDosen.number * listDosen.size)}">1</td>
          <td class="p-3" th:text="${dataDosen.getNama()}">Dosen satu</td>
          <td class="p-3" th:text="${dataDosen.getPerguruanTinggi().getNamaPerguruanTinggi()}">IAI Tazkia</td>
          <td>
            <select class="form-select select2" th:id="${dataDosen.id + '-asesor1'}" onchange="simpanAsesor1(this)" name="asesor1" aria-label="Default select example">
              <option value="-" >Pilih Asesor 1</option>
              <option th:each="data : ${listAsesor}"
                      th:selected="(${data} == *{dataDosen.asesorSatu})"
                      th:text="${data.namaLengkap}"
                      th:value="${data.id}">Dosen Biasa</option>
            </select>
            <span style="color: red; display: none;font-size: 10px; padding: 10px;" th:id="${dataDosen.id+'alert1'}">Data tidak tersimpan karena asesor 1 tidak boleh sama dengan asesor 2</span>
          </td>
          <td>
            <select class="form-select select2" th:id="${dataDosen.id + '-asesor2'}" th:if="${dataDosen.asesorSatu == null}" disabled onchange="simpanAsesor2(this)" name="asesor2" aria-label="Default select example">
              <option value="-" >Pilih Asesor 2</option>
              <option th:each="data : ${listAsesor}"
                      th:text="${data.namaLengkap}"
                      th:selected="(${data} == *{dataDosen.asesorDua})"
                      th:value="${data.id}">Dosen Biasa</option>
            </select>
            <select class="form-select select2" th:id="${dataDosen.id + '-asesor2'}" th:if="${dataDosen.asesorSatu != null}" onchange="simpanAsesor2(this)" name="asesor2" aria-label="Default select example">
              <option value="-" >Pilih Asesor 2</option>
              <option th:each="data : ${listAsesor}"
                      th:text="${data.namaLengkap}"
                      th:selected="(${data} == *{dataDosen.asesorDua})"
                      th:value="${data.id}">Dosen Biasa</option>
            </select>
            <span style="color: red;display: none; font-size: 10px; padding: 10px;" th:id="${dataDosen.id+'alert2'}">Data tidak tersimpan karena asesor 2 tidak boleh sama dengan asesor 1</span>
          </td>
          <td>
            <button onclick="reset(this)" th:id="${dataDosen.id}" class="btn btn-secondary">Kosongkan</button>
          </td>
        </tr>
        </tbody>
      </table>

      <nav>
        <ul class="pagination" sd:pagination="full">
          <!-- Pagination created by SpringDataDialect, this content is just for mockup -->
          <li class="disabled"><a href="#" aria-label="Previous"><span aria-hidden="true">&laquo;</span></a></li>
          <li class="active bg-success"><a href="#">1 <span class="sr-only">(current)</span></a></li>
        </ul>
      </nav>
    </div>
    <!--    </div>-->
  </div>
</div>
<div layout:fragment="footer" class="script">
  <!--  <script>-->
  <!--    $(function () {-->
  <!--      $('.select2').select2()-->
  <!--    })-->
  <!--  </script>-->
  <!--  <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.8.3/jquery.min.js"></script>-->
  <script>
    $( '.select2' ).select2( {
      theme: "bootstrap-5",
      width: $( this ).data( 'width' ) ? $( this ).data( 'width' ) : $( this ).hasClass( 'w-100' ) ? '100%' : 'style',
      placeholder: $( this ).data( 'placeholder' ),
    } );


    var delay = (function () {
      var timer = 0;
      return function (callback, ms) {
        clearTimeout(timer);
        timer = setTimeout(callback, ms);
      };
    })();

    function simpanAsesor1(arg) {
      var id = arg.getAttribute('id');
      var value = arg.value;
      var idDosen =  id.substring(0, id.length - 8);

      const url = '/dosen/update-asessor1/'+idDosen+'?idAsessor='+value;
      $.getJSON(url, function (data) {

        if (data.code == 'CONFLICT'){
          document.getElementById(idDosen+'alert1').style.display='block';
          delay(function () {
            $("#"+id).val(data.message).trigger('change')
          }, 1000);
        }else {
          if (value != '-'){
            $('#'+idDosen + '-asesor2').prop('disabled', false);
          }
          if (value == '-'){
            $('#'+idDosen + '-asesor2').prop('disabled', true);
              $('#'+idDosen + '-asesor2').val('-').trigger('change')

          }
          document.getElementById(idDosen+'alert1').style.display='none';
        }
      });
    }

    function simpanAsesor2(arg) {
      var id = arg.getAttribute('id');
      var value = arg.value;
      var idDosen =  id.substring(0, id.length - 8);

      const url = '/dosen/update-asessor2/'+idDosen+'?idAsessor='+value;
      $.getJSON(url, function (data) {

        if (data.code == 'CONFLICT'){
          document.getElementById(idDosen+'alert2').style.display='block';
          delay(function () {
            $("#"+id).val(data.message).trigger('change')
          }, 1000);
        }else {
          document.getElementById(idDosen+'alert2').style.display='none';
        }
      });
    }

    function reset(arg) {
      var id = arg.getAttribute('id');
      var ases1 = id+'-asesor1';
      var ases2 = id+'-asesor2';

      const url = '/dosen/reset-asessor/'+id;
      $.getJSON(url, function (data) {
        $("#"+ases1).val('-').trigger('change')
        $("#"+ases2).val('-').trigger('change')
      });



    }


  </script>

</div>
</body>
</html>